<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\works;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\works\ServiceWorkLists;
use app\adminapi\logic\master_worker\MasterWorkerLogic;
use app\adminapi\logic\works\ServiceWorkLogic;
use app\adminapi\validate\works\ServiceWorkValidate;


/**
 * ServiceWork控制器
 * Class WorksController
 * @package app\adminapi\controller\works
 */
class ServiceWorkController extends BaseAdminController
{


    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function lists()
    {
        return $this->dataLists(new ServiceWorkLists());
    }

    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function edit()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('edit');
        $workDetail = ServiceWorkLogic::detail($params);
        $result = ServiceWorkLogic::edit($params);
        if (true === $result) {
            if(strtotime($workDetail['appointment_time']) !== strtotime($params['appointment_time']) && !empty($workDetail['master_worker_id'])){
                $masterDetail = MasterWorkerLogic::detail(['id'=>$workDetail['master_worker_id']]);
                // 修改预约时间通知【给用户的通知】
                $res = event('Notice',  [
                    'scene_id' => 117,
                    'params' => [
                        'user_id' => $workDetail['user_id'],
                        'date' => $params['appointment_time'],
                        'tel' => asteriskString($masterDetail['mobile']),
                    ]
                ]);
                // 修改预约时间通知【给工程师的通知，仅限公众号】
                $res = event('Notice',  [
                    'scene_id' => 118,
                    'params' => [
                        'user_id' => $workDetail['master_worker_id'],
                        'order_id' => $workDetail['id'],
                        'thing4' => $workDetail['title'],
                        'time5' => $workDetail['appointment_time'],
                        'time6' => $params['appointment_time'],
                        'thing11' => (iconv_strlen($workDetail['address'])>15)?(mb_substr($workDetail['address'],0,15,'UTF-8').'...'):$workDetail['address'],
                        'phone_number8' => asteriskString($workDetail['mobile']),
                    ]
                ]);
            }
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(ServiceWorkLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function delete()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('delete');
        $result = ServiceWorkLogic::edit($params);
        if (true === $result) {
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->success('分配成功', [], 1, 1);
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function detail()
    {
        $params = (new ServiceWorkValidate())->goCheck('detail');
        $result = ServiceWorkLogic::detail($params);
        return $this->data($result);
    }


    public function allocateWorker()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('allocateWorker');
        $result = ServiceWorkLogic::allocateWorker($params,$this->adminInfo);
        if (true === $result) {
            // 工程师派单通知【给工程师的通知】【公众号通知，不发短信】
            $workDetail = ServiceWorkLogic::detail($params);
            $res = event('Notice',  [
                'scene_id' => 113,
                'params' => [
                    'user_id' => $params['master_worker_id'],
                    'order_id' => $params['id'],
                    'thing9' => $workDetail['title'],
                    'time7' => $workDetail['appointment_time'],
                    'thing8' => (iconv_strlen($workDetail['address'])>15)?(mb_substr($workDetail['address'],0,15,'UTF-8').'...'):$workDetail['address'],
                    'phone_number6' => asteriskString($workDetail['mobile']),
                ]
            ]);
            return $this->success('分配工程师成功', [], 1, 1);
        }
        return $this->fail(ServiceWorkLogic::getError());
    }
    public function cancelWorker()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('detail');
        $result = ServiceWorkLogic::cancel($params);
        if (true === $result) {
            return $this->success('取消工单成功！', [], 1, 1);
        }
        return $this->fail(ServiceWorkLogic::getError());
    }
    public function settlementMaster()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('detail');
        $result = ServiceWorkLogic::settlement($params);
        if (true === $result) {
            return $this->success('操作成功！', [], 1, 1);
        }
        return $this->fail(ServiceWorkLogic::getError());
    }

    public function notApproved()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('detail');
        $result = ServiceWorkLogic::notApproved($params);
        if (true === $result) {
            return $this->success('操作成功！', [], 1, 1);
        }
        return $this->fail(ServiceWorkLogic::getError());
    }

    public function cancelAllocation()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('allocateWorker');
        $result = ServiceWorkLogic::cancelAllocation($params,$this->adminInfo);
        if (true === $result) {
            return $this->success('操作成功！', [], 1, 1);
        }
        return $this->fail(ServiceWorkLogic::getError());
    }


    public function addCustomerLog()
    {
        $params = (new ServiceWorkValidate())->post()->goCheck('detail',[
            'admin_id' => $this->adminId,
        ]);
        $result = ServiceWorkLogic::addCustomerLog($params);
        if (true === $result) {
            return $this->success('操作成功！', [], 1, 1);
        }
        return $this->fail(ServiceWorkLogic::getError());
    }
}